## picolisp 23.2

=== src/Makefile ===
# 24sep22 Software Lab. Alexander Burger

.SILENT:

CC = clang
PIL = ../pil  # pil
ASM = opt -O3  # llvm-as
LLC = llc
LINK = llvm-link
MAIN = -rdynamic -lc -lutil -lm -ldl -lreadline -lffi
SHARED = -shared
STRIP = strip

LLVM = $(shell llvm-config --version | cut -d. -f1)
ifeq ($(shell test $(LLVM) -ge 15; echo $$?), 0)
	ASM += -opaque-pointers
endif

OS = $(shell uname)
CPU = $(shell uname -m)

BIN = ../bin
LIB = ../lib

INC = lib/llvm.l vers.l defs.l glob.l dec.l
SRC = main.l gc.l big.l sym.l io.l db.l apply.l flow.l subr.l

all: $(LIB)/sysdefs $(BIN)/picolisp $(LIB)/ext.so $(LIB)/ht.so $(BIN)/balance $(BIN)/ssl $(BIN)/httpGate

# System definitions
$(LIB)/sysdefs: sysdefs.c
	$(CC) -w -D_OS='"$(OS)"' -D_CPU='"$(CPU)"' sysdefs.c  &&  ./a.out > $(LIB)/sysdefs  &&  rm ./a.out

# Base system
$(BIN)/picolisp: picolisp.bc
	mkdir -p $(BIN) $(LIB)
	$(LLC) picolisp.bc -relocation-model=pic -o picolisp.s
	$(CC) picolisp.s -o $(BIN)/picolisp $(MAIN)
	$(STRIP) $(BIN)/picolisp

picolisp.bc: base.bc lib.bc
	$(LINK) -o picolisp.bc base.bc lib.bc

base.bc: base.ll
	$(ASM) -o base.bc base.ll

base.ll: $(INC) $(SRC)
	$(PIL) lib/llvm.l main.l -bye > base.ll
	mv base.map $(LIB)/map

lib.bc: pico.h lib.c
	$(CC) -O3 -w -c -o lib.bc -D_OS='"$(OS)"' -D_CPU='"$(CPU)"' `pkg-config --cflags libffi` -emit-llvm lib.c

# Extension libraries
$(LIB)/ext.so: ext.bc
	$(LLC) ext.bc -relocation-model=pic -o ext.s
	$(CC) ext.s -o $(LIB)/ext.so $(SHARED)
	$(STRIP) $(LIB)/ext.so

ext.bc: ext.ll
	$(ASM) -o ext.bc ext.ll

ext.ll: $(INC) ext.l
	$(PIL) lib/llvm.l ext.l -bye > ext.ll

$(LIB)/ht.so: ht.bc
	$(LLC) ht.bc -relocation-model=pic -o ht.s
	$(CC) ht.s -o $(LIB)/ht.so $(SHARED)
	$(STRIP) $(LIB)/ht.so

ht.bc: ht.ll
	$(ASM) -o ht.bc ht.ll

ht.ll: $(INC) ht.l
	$(PIL) lib/llvm.l ht.l -bye > ht.ll

# Tools
$(BIN)/balance: balance.c
	$(CC) -O3 -w -o $(BIN)/balance balance.c
	$(STRIP) $(BIN)/balance

# Gate
$(BIN)/ssl: ssl.c
	$(CC) -O3 -w -o $(BIN)/ssl ssl.c -lssl -lcrypto
	$(STRIP) $(BIN)/ssl

$(BIN)/httpGate: httpGate.c
	$(CC) -O3 -w -o $(BIN)/httpGate httpGate.c -lssl -lcrypto
	$(STRIP) $(BIN)/httpGate

# Clean up
clean:
	rm -f *.ll *.bc *.s

clean2: clean
	rm -f $(BIN)/balance $(BIN)/ssl $(BIN)/httpGate

=== debian/changelog ===
picolisp (23.2-1) unstable; urgency=medium

  * New upstream version 23.2
  * debian/control: bump standards-version to 4.6.2, no changes needed

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Wed, 08 Feb 2023 21:05:43 +0900

picolisp (22.12-1) unstable; urgency=medium

  * New upstream version 22.12

 -- Kan-Ru Chen <koster@debian.org>  Wed, 28 Dec 2022 10:25:18 +0800

picolisp (22.9-1) unstable; urgency=medium

  * New upstream version 22.9

 -- Kan-Ru Chen <koster@debian.org>  Sat, 01 Oct 2022 21:32:28 +0900

=== debian/control ===
Source: picolisp
Section: lisp
Priority: optional
Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
Build-Depends: debhelper (>= 12), dpkg-dev (>= 1.18.11~), libssl-dev,
 libreadline-dev, libffi-dev, pkg-config, clang, llvm, picolisp
Standards-Version: 4.6.2
Homepage: http://picolisp.com/
Vcs-Git: https://salsa.debian.org/koster/picolisp.git
Vcs-Browser: https://salsa.debian.org/koster/picolisp

Package: picolisp
Architecture: amd64 arm64 mips64el ppc64el s390x
Pre-Depends: dpkg (>= 1.17.5)
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: tinymce, w3m
Description: Lisp interpreter and application server framework
 Pico Lisp can be viewed from two different aspects: As a general
 purpose programming language, and a dedicated application server
 framework.
 .
 As a programming language, Pico Lisp provides a 1-to-1 mapping of a
 clean and powerful Lisp derivate, to a simple and efficient virtual
 machine. It supports persistent objects as a first class data type,
 resulting in a database system of Entity/Relation classes and a
 Prolog-like query language tightly integrated into the system.
 .
 As an application server framework, Pico Lisp provides for database
 management (including multi-user synchronization, DB garbage collection
 journalling and replication), web interface integrated (and generated
 from) the application data model, and an application server.

## picolisp 23.6

=== debian/changelog ===
picolisp (23.6-1) unstable; urgency=medium

  * New upstream version 23.6
  * debian/control: remove s390x
  * debian/picolisp.doc-base: fix index page path
  * debian/patches: fix bootstrap llir

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sat, 01 Jul 2023 16:12:19 +0900

picolisp (23.3-2) unstable; urgency=medium

  * New upstream version 23.3 uploaded to unstable

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Wed, 21 Jun 2023 07:13:26 +0900

picolisp (23.3-1) experimental; urgency=medium

  [ Kan-Ru Chen ]
  * New upstream version 23.3
  * d/picolisp.install: add bin/pty
  * d/patches: drop shbang patches

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sun, 02 Apr 2023 08:34:42 +0900

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
 Vcs-Browser: https://salsa.debian.org/koster/picolisp
 
 Package: picolisp
-Architecture: amd64 arm64 mips64el ppc64el s390x
+Architecture: amd64 arm64 mips64el ppc64el
 Pre-Depends: dpkg (>= 1.17.5)
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Suggests: tinymce, w3m

## picolisp 23.12

=== src/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# 24sep22 Software Lab. Alexander Burger
+# 05sep23 Software Lab. Alexander Burger
 
 .SILENT:
 
@@ -12,7 +12,7 @@
 STRIP = strip
 
 LLVM = $(shell llvm-config --version | cut -d. -f1)
-ifeq ($(shell test $(LLVM) -ge 15; echo $$?), 0)
+ifeq ($(shell test $(LLVM) -ge 15 -a $(LLVM) -lt 17; echo $$?), 0)
 	ASM += -opaque-pointers
 endif

=== debian/changelog ===
picolisp (23.12-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:15:29 +1100

picolisp (23.12-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 21:03:11 +0000

picolisp (23.12-1) unstable; urgency=medium

  * New upstream version 23.12

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Tue, 26 Dec 2023 20:30:42 +0900

picolisp (23.9-1) unstable; urgency=medium

  * New upstream version 23.9

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Mon, 02 Oct 2023 08:16:20 +0900

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: picolisp
 Section: lisp
 Priority: optional
-Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
 Build-Depends: debhelper (>= 12), dpkg-dev (>= 1.18.11~), libssl-dev,
  libreadline-dev, libffi-dev, pkg-config, clang, llvm, picolisp
 Standards-Version: 4.6.2

## picolisp 24.6

=== src/Makefile ===
--- 
+++ 
@@ -1,10 +1,10 @@
-# 05sep23 Software Lab. Alexander Burger
+# 21jun24 Software Lab. Alexander Burger
 
 .SILENT:
 
 CC = clang
 PIL = ../pil  # pil
-ASM = opt -O3  # llvm-as
+ASM = opt -O2  # llvm-as
 LLC = llc
 LINK = llvm-link
 MAIN = -rdynamic -lc -lutil -lm -ldl -lreadline -lffi
@@ -93,4 +93,4 @@
 	rm -f *.ll *.bc *.s
 
 clean2: clean
-	rm -f $(BIN)/balance $(BIN)/ssl $(BIN)/httpGate
+	rm -f $(LIB)/sysdefs $(BIN)/balance $(BIN)/ssl $(BIN)/httpGate

=== debian/changelog ===
picolisp (24.6-1) unstable; urgency=medium

  * New upstream version 24.6

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sun, 30 Jun 2024 18:50:45 +0900

picolisp (24.3-1) unstable; urgency=medium

  * New upstream version 24.3
  * debian/control: build-dep pkg-config -> pkgconf
  * debian/control: bump standards-version to 4.7.0, no changes needed

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sun, 07 Apr 2024 22:22:51 +0900

## picolisp 24.9

=== debian/changelog ===
picolisp (24.9-1) unstable; urgency=medium

  * New upstream version 24.9

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sun, 29 Sep 2024 20:50:26 +0900

## picolisp 24.12

=== debian/changelog ===
picolisp (24.12-1) unstable; urgency=medium

  * New upstream version 24.12

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Mon, 30 Dec 2024 17:59:38 +0900

## picolisp 25.3

=== src/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# 21jun24 Software Lab. Alexander Burger
+# 23dec24 Software Lab. Alexander Burger
 
 .SILENT:
 
@@ -7,7 +7,6 @@
 ASM = opt -O2  # llvm-as
 LLC = llc
 LINK = llvm-link
-MAIN = -rdynamic -lc -lutil -lm -ldl -lreadline -lffi
 SHARED = -shared
 STRIP = strip
 
@@ -35,7 +34,7 @@
 $(BIN)/picolisp: picolisp.bc
 	mkdir -p $(BIN) $(LIB)
 	$(LLC) picolisp.bc -relocation-model=pic -o picolisp.s
-	$(CC) picolisp.s -o $(BIN)/picolisp $(MAIN)
+	$(CC) picolisp.s -o $(BIN)/picolisp -rdynamic -lc -lutil -lm -ldl `pkg-config --libs readline libffi`
 	$(STRIP) $(BIN)/picolisp
 
 picolisp.bc: base.bc lib.bc

=== debian/changelog ===
picolisp (25.3-1) unstable; urgency=medium

  * New upstream version 25.3

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sat, 29 Mar 2025 19:47:21 +0900

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: picolisp
 Section: lisp
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
+Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
 Build-Depends: debhelper (>= 12), dpkg-dev (>= 1.18.11~), libssl-dev,
- libreadline-dev, libffi-dev, pkg-config, clang, llvm, picolisp
-Standards-Version: 4.6.2
+ libreadline-dev, libffi-dev, pkgconf, clang, llvm, picolisp
+Standards-Version: 4.7.0
 Homepage: http://picolisp.com/
 Vcs-Git: https://salsa.debian.org/koster/picolisp.git
 Vcs-Browser: https://salsa.debian.org/koster/picolisp

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

override_dh_auto_build:
ifeq (,$(filter nobootstrap,$(DEB_BUILD_OPTIONS)))
	cd src && pil lib/llvm.l main.l -bye > base.ll && mv base.map ../lib/map
	cd src && pil lib/llvm.l ext.l -bye > ext.ll
	cd src && pil lib/llvm.l ht.l -bye > ht.ll
endif
	make -C src
	mkdir -p build/bash_completion.d
	cp lib/bash_completion build/bash_completion.d/pil

override_dh_auto_test:
	HOME=$(CURDIR)/build $(CURDIR)/pil test/lib.l -bye + < /dev/null

override_dh_auto_install:
	chmod a-x lib/replica.l
	dh_install -X.bc src   usr/lib/picolisp

override_dh_installdocs:
	dh_installdocs

override_dh_auto_clean:
	-rm -rf build
	make -C src clean

override_dh_compress:
	dh_compress -X.l

override_dh_strip:
	dh_strip --no-automatic-dbgsym

override_dh_dwz: ;

%:
	dh $@

## picolisp 25.6

=== debian/changelog ===
picolisp (25.6-2) unstable; urgency=medium

  * Upload 25.6 to unstable

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Tue, 09 Sep 2025 22:26:38 +0900

picolisp (25.6-1) experimental; urgency=medium

  * New upstream version 25.6

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Mon, 30 Jun 2025 22:51:35 +0900

## picolisp 25.9

=== src/Makefile ===
--- 
+++ 
@@ -1,10 +1,10 @@
-# 23dec24 Software Lab. Alexander Burger
+# 13sep25 Software Lab. Alexander Burger
 
 .SILENT:
 
 CC = clang
-PIL = ../pil  # pil
-ASM = opt -O2  # llvm-as
+PIL = ../pil
+ASM = opt -O2
 LLC = llc
 LINK = llvm-link
 SHARED = -shared
@@ -25,6 +25,7 @@
 SRC = main.l gc.l big.l sym.l io.l db.l apply.l flow.l subr.l
 
 all: $(LIB)/sysdefs $(BIN)/picolisp $(LIB)/ext.so $(LIB)/ht.so $(BIN)/balance $(BIN)/ssl $(BIN)/httpGate
+so: $(LIB)/picolisp.so
 
 # System definitions
 $(LIB)/sysdefs: sysdefs.c
@@ -32,7 +33,7 @@
 
 # Base system
 $(BIN)/picolisp: picolisp.bc
-	mkdir -p $(BIN) $(LIB)
+	mkdir -p $(BIN)
 	$(LLC) picolisp.bc -relocation-model=pic -o picolisp.s
 	$(CC) picolisp.s -o $(BIN)/picolisp -rdynamic -lc -lutil -lm -ldl `pkg-config --libs readline libffi`
 	$(STRIP) $(BIN)/picolisp
@@ -43,12 +44,31 @@
 base.bc: base.ll
 	$(ASM) -o base.bc base.ll
 
-base.ll: $(INC) $(SRC)
-	$(PIL) lib/llvm.l main.l -bye > base.ll
+base.ll: $(INC) $(SRC) lib/ex.l
+	$(PIL) lib/llvm.l lib/ex.l main.l -bye > base.ll
 	mv base.map $(LIB)/map
 
 lib.bc: pico.h lib.c
-	$(CC) -O3 -w -c -o lib.bc -D_OS='"$(OS)"' -D_CPU='"$(CPU)"' `pkg-config --cflags libffi` -emit-llvm lib.c
+	$(CC) -O3 -w -c -o lib.bc -D_OS='"$(OS)"' -D_CPU='"$(CPU)"' -emit-llvm lib.c
+
+# Base system as shared library
+$(LIB)/picolisp.so: picolisp.so.bc
+	$(LLC) picolisp.so.bc -relocation-model=pic -o picolisp.so.s
+	$(CC) picolisp.so.s -o $(LIB)/picolisp.so $(SHARED)
+	$(STRIP) $(LIB)/picolisp.so
+
+picolisp.so.bc: base.so.bc lib.so.bc
+	$(LINK) -o picolisp.so.bc base.so.bc lib.so.bc
+
+base.so.bc: base.so.ll
+	$(ASM) -o base.so.bc base.so.ll
+
+base.so.ll: $(INC) $(SRC) lib/so.l
+	$(PIL) lib/llvm.l -quiche lib/so.l main.l -bye > base.so.ll
+	rm base.map
+
+lib.so.bc: pico.h lib.so.c
+	$(CC) -O3 -w -c -fPIC -o lib.so.bc -D_OS='"$(OS)"' -D_CPU='"$(CPU)"' -emit-llvm lib.so.c
 
 # Extension libraries
 $(LIB)/ext.so: ext.bc

=== debian/changelog ===
picolisp (25.9-1) unstable; urgency=medium

  * New upstream version 25.9
  * debian/patches: drop LLIR patch
  * debian/rules: update bootstrap commands
  * debian/control: bump standards-version to 4.7.2, no changes needed

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Wed, 01 Oct 2025 22:30:47 +0900

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
 Build-Depends: debhelper (>= 12), dpkg-dev (>= 1.18.11~), libssl-dev,
  libreadline-dev, libffi-dev, pkgconf, clang, llvm, picolisp
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: http://picolisp.com/
 Vcs-Git: https://salsa.debian.org/koster/picolisp.git
 Vcs-Browser: https://salsa.debian.org/koster/picolisp

=== debian/rules ===
--- 
+++ 
@@ -5,9 +5,12 @@
 
 override_dh_auto_build:
 ifeq (,$(filter nobootstrap,$(DEB_BUILD_OPTIONS)))
-	cd src && pil lib/llvm.l main.l -bye > base.ll && mv base.map ../lib/map
-	cd src && pil lib/llvm.l ext.l -bye > ext.ll
-	cd src && pil lib/llvm.l ht.l -bye > ht.ll
+	-ln -s /usr/bin/picolisp $(CURDIR)/bin/picolisp
+	-rm src/base.ll src/ext.ll src/ht.ll
+	make -C src ../lib/sysdefs
+	make -C src base.ll
+	make -C src ext.ll
+	make -C src ht.ll
 endif
 	make -C src
 	mkdir -p build/bash_completion.d

=== debian/watch ===
version=3

https://software-lab.de/down.html picoLisp-(.*)\.tgz

## picolisp 25.12

=== src/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# 13sep25 Software Lab. Alexander Burger
+# 05nov25 Software Lab. Alexander Burger
 
 .SILENT:
 
@@ -49,7 +49,7 @@
 	mv base.map $(LIB)/map
 
 lib.bc: pico.h lib.c
-	$(CC) -O3 -w -c -o lib.bc -D_OS='"$(OS)"' -D_CPU='"$(CPU)"' -emit-llvm lib.c
+	$(CC) -O3 -w -c -o lib.bc -D_OS='"$(OS)"' -D_CPU='"$(CPU)"' `pkg-config --cflags libffi` -emit-llvm lib.c
 
 # Base system as shared library
 $(LIB)/picolisp.so: picolisp.so.bc
@@ -68,7 +68,7 @@
 	rm base.map
 
 lib.so.bc: pico.h lib.so.c
-	$(CC) -O3 -w -c -fPIC -o lib.so.bc -D_OS='"$(OS)"' -D_CPU='"$(CPU)"' -emit-llvm lib.so.c
+	$(CC) -O3 -w -c -fPIC -o lib.so.bc -D_OS='"$(OS)"' -D_CPU='"$(CPU)"' `pkg-config --cflags libffi` -emit-llvm lib.so.c
 
 # Extension libraries
 $(LIB)/ext.so: ext.bc

=== debian/changelog ===
picolisp (25.12-1) unstable; urgency=medium

  * New upstream version 25.12
  * debian/watch: use version 5 format
  * debian/compat: replaced with debhelper-compat in Build-Depends

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Mon, 29 Dec 2025 00:16:04 +0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: lisp
 Priority: optional
 Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
-Build-Depends: debhelper (>= 12), dpkg-dev (>= 1.18.11~), libssl-dev,
+Build-Depends: debhelper-compat (= 12), dpkg-dev (>= 1.18.11~), libssl-dev,
  libreadline-dev, libffi-dev, pkgconf, clang, llvm, picolisp
 Standards-Version: 4.7.2
 Homepage: http://picolisp.com/

=== debian/watch ===
Version: 5

Source: https://software-lab.de/down.html
Matching-Pattern: picoLisp-(.*)\.tgz
